;============================================
; Checkbox Control Testbed
;============================================


	INCLUDE	\masm32\include\masm32rt.inc


;============================================
; Defines, macros, prototypes, etc.
;============================================

WinMain			PROTO :DWORD
CheckboxProc		PROTO hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

$mainWindowWidth	EQU 250
$mainWindowHeight	EQU 200

$chkboxX		EQU 50
$chkboxY		EQU 70
$chkboxWidth		EQU 120
$chkboxHeight		EQU 20

$chkboxID		EQU 2000

;===== Window styles: =====
$mainWinAttrs		EQU WS_OVERLAPPED OR WS_CLIPCHILDREN OR WS_VISIBLE OR WS_CAPTION OR WS_SIZEBOX OR WS_SYSMENU
$chkboxAttrs		EQU WS_CHILD OR WS_VISIBLE OR BS_AUTOCHECKBOX

;===== Window background colors: =====
$bkRED			EQU 254
$bkGRN			EQU 243
$bkBLUE			EQU 199

$BkColor		EQU $bkRED OR ($bkGRN SHL 8) OR ($bkBLUE SHL 16)


;============================================
; HERE BE DATA
;============================================

.data

InstanceHandle		HWND ?
MainWinHandle		HWND ?
CheckboxHandle		HWND ?

OldCheckboxProcPtr	DD ?


MainClassName		DB "ChildText", 0
CheckboxClassName	DB "button", 0

MainTitleText		DB "Checkbox Control Testbed", 0

CheckboxText		DB "Click this checkbox",  0



;============================================
; CODE
;============================================
.code


start:
	INVOKE	GetModuleHandle, NULL
	MOV	InstanceHandle, EAX

	INVOKE	WinMain, EAX
	INVOKE	ExitProcess, EAX


;====================================================================
; Mainline proc
;====================================================================

WinMain	PROC hInst:DWORD
	LOCAL	wc:WNDCLASSEX, msg:MSG, brush:HBRUSH, wX:DWORD, wY:DWORD


; Create  brush to set background color:
	INVOKE	CreateSolidBrush, $BkColor
	MOV	brush, EAX

; Register class for parent window:
	MOV	wc.cbSize, SIZEOF WNDCLASSEX
	MOV	wc.style,  CS_HREDRAW or CS_VREDRAW or CS_BYTEALIGNWINDOW
	MOV	wc.lpfnWndProc, OFFSET MainWindowProc
	MOV	wc.cbClsExtra, NULL
	MOV	wc.cbWndExtra, NULL
	MOV	EAX, hInst
	MOV	wc.hInstance, EAX
	MOV	EAX, brush
	MOV	wc.hbrBackground, EAX
	MOV	wc.lpszMenuName,  NULL
	MOV	wc.lpszClassName, OFFSET MainClassName
	MOV	wc.hIcon, NULL
	INVOKE	LoadCursor, NULL, IDC_ARROW
	MOV	wc.hCursor, EAX
	MOV	wc.hIconSm, 0
	INVOKE	RegisterClassEx, ADDR wc

;******** THIS DOES NOT WORK!********
; Register class for checkbox controls:
;	MOV	wc.lpfnWndProc, OFFSET CheckboxProc
;	MOV	wc.lpszClassName, OFFSET CheckboxClassName
;	INVOKE	RegisterClassEx, ADDR wc

	INVOKE	GetSystemMetrics, SM_CXSCREEN
	MOV	EDX, $mainWindowWidth
	CALL	CenterDim
	MOV	wX, EAX
	INVOKE	GetSystemMetrics, SM_CYSCREEN
	MOV	EDX, $mainWindowHeight
	CALL	CenterDim
	MOV	wY, EAX

; Create our main window:

	INVOKE	CreateWindowEx, WS_EX_OVERLAPPEDWINDOW, ADDR MainClassName, ADDR MainTitleText,
		$mainWinAttrs, wX, wY, $mainWindowWidth, $mainWindowHeight,
		NULL, NULL, hInst, NULL
	MOV	MainWinHandle, EAX
	INVOKE	ShowWindow, EAX, SW_SHOWNORMAL

; Create checkbox control:
	INVOKE	CreateWindowEx,	WS_EX_LEFT, ADDR CheckboxClassName, ADDR CheckboxText,
			$chkboxAttrs, $chkboxX, $chkboxY, $chkboxWidth, $chkboxHeight,
			MainWinHandle, $chkboxID, InstanceHandle, NULL

	MOV	CheckboxHandle, EAX

; This doesn't help either!
;	INVOKE	SetWindowLong, EAX, GWL_WNDPROC, CheckboxProc
;	MOV	OldCheckboxProcPtr, EAX

	INVOKE	GetStockObject, ANSI_VAR_FONT
	INVOKE	SendMessage, CheckboxHandle, WM_SETFONT, EAX, TRUE
	INVOKE	CheckDlgButton, MainWinHandle, $chkboxID, BST_UNCHECKED	;Set button state to unchecked.
	INVOKE	UpdateWindow, CheckboxHandle

;============= Message loop ===================
msgloop:
	INVOKE	GetMessage, ADDR msg, NULL, 0, 0
	OR	EAX, EAX				;EAX = 0 = exit
	JZ	exit
	INVOKE	TranslateMessage, ADDR msg
	INVOKE	DispatchMessage, ADDR msg
	JMP	msgloop

exit:	MOV	EAX, msg.wParam
	RET

WinMain		ENDP


;====================================================================
; Main Window Proc
;====================================================================

MainWindowProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

	MOV	EAX, uMsg
	CMP	EAX, WM_COMMAND
	JE	dowincmd
	CMP	EAX, WM_CREATE
	JE	docreate
	CMP	EAX, WM_CLOSE
	JE	doclose

dodefault:
; use DefWindowProc for all other messages:
	INVOKE	DefWindowProc, hWin, uMsg, wParam, lParam
	RET

dowincmd:

docreate:
	XOR	EAX, EAX
	RET

doclose:
	INVOKE	PostQuitMessage, NULL
	MOV	EAX, TRUE
	RET


MainWindowProc	ENDP



;====================================================================
; Checkbox Control Proc (currently unused)
;
; Attempted to intercept WM_ERASEBKGND message to set the background
; color, but with no success ...
;====================================================================

CheckboxProc	PROC hWin:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
		LOCAL	hDC:HDC, hbr:HBRUSH, gpRect:RECT, ps:PAINTSTRUCT

	MOV	EAX, uMsg
	CMP	EAX, WM_ERASEBKGND
	JE	do_background

do_default:
	INVOKE	CallWindowProc, OldCheckboxProcPtr, hWin, uMsg, wParam, lParam
	RET

do_background:
	INVOKE	CreateSolidBrush, $BkColor
	INVOKE	SelectObject, wParam, EAX
	MOV	EAX, TRUE
	RET

CheckboxProc	ENDP



;====================================================================
; CenterDim
;
; Returns half screen dimension (X or Y) minus half window dimension
;
; On entry,
;	EAX = screen dimension
;	EDX = window dimension
;
; Returns:
;	sdim/2 - wdim/2
;====================================================================

CenterDim	PROC

	SHR	EAX, 1				;divide screen dimension by 2
	SHR	EDX, 1				;divide window dimension by 2
	SUB	EAX, EDX
	RET					;Return w/# in EAX

CenterDim	ENDP


	END	start

